{
  Autor: Michael Springwald

  Datum: Mittwoch, 11.03.2015

  Stellt eine Seiten Verwaltung zuverfügung
}

unit uplwebPage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, contnrs;

type
  TPLWebPageList = class;

  { TPLWebPage }
  TPLWebPage = class
  private
    fID: String;
    fName: String;
    fPages: TPLWebPageList;
  protected

  public
    constructor Create(const aName,aID:String);
    destructor Destroy; override;
  published
    property Name:String read fName write fName;
    property ID:String read fID write fID;
    property Pages:TPLWebPageList read fPages write fPages;
  end; // TPLWebPage

  { TPLWebPageList }
  TPLWebPageList = class
  private
    fID: String;
    fName: String;
    function GetCount: Integer;
    function GetItem(aIndex: Integer): TPLWebPage;
  protected

  public
    Items:TObjectList;
    constructor Create(const aName, aID:string);
    destructor Destroy; override;

    function FindByName(const aName:string):TPLWebPage;
    function Add(const aName, aID:String):TPLWebPage;

    property Item[aIndex:Integer]:TPLWebPage read GetItem; default;
    property Count:Integer read GetCount;
  published
    property Name:String read fName write fName;
    property ID:String read fID write fID;
  end; // TPLWebPageList

implementation

function TPLWebPageList.GetItem(aIndex: Integer): TPLWebPage;
begin
  result:=Items[aIndex] as TPLWebPage;
end; // TPLWebPageList.GetItem

function TPLWebPageList.GetCount: Integer;
begin
  result:=Items.Count;
end; // TPLWebPageList.GetCount

constructor TPLWebPageList.Create(const aName, aID: string);
begin
  inherited Create;
  Name:=aName;
  ID:=aID;
  Items:=TObjectList.Create;
end; // TPLWebPageList.Create

destructor TPLWebPageList.Destroy;
begin
  FreeAndNil(Items);
  inherited Destroy;
end; // TPLWebPageList.Destroy

function TPLWebPageList.FindByName(const aName: string): TPLWebPage;
var
  i:integer;
begin
  result:=nil;
  for i:=0 to Count-1 do begin
    if Item[i].Name = aName then begin
      result:=item[i];
      break;
    end;
  end;
end; // TPLWebPageList.FindByName

function TPLWebPageList.Add(const aName, aID: String): TPLWebPage;
begin
  result:=Item[Items.Add(TPLWebPage.Create(aName, aID))];
end; // TPLWebPageList.Add

{ TPLWebPage }
constructor TPLWebPage.Create(const aName, aID: String);
begin
  inherited Create;
  Name:=aName;
  ID:=aID;
  fPages:=nil;
end; // TPLWebPage.Create

destructor TPLWebPage.Destroy;
begin
  if Assigned(fPages) then FreeAndNil(fPages);
  inherited Destroy;
end; // TPLWebPage.Destroy

end.

