{
  Notiert:
  http://wiki.selfhtml.org/wiki/JavaScript/Objekte/DOM/document/forms/elements

  www.bennyn.de/programmierung/java/html5-websocket-server-mit-java-und-client-mit-javascript.html
}

unit uplWebSocket;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, synautil,strutils,
  blcksock, customserver2, WebSocket2, synachar,
  uplthreadtimertest, uplwebPage;

type

  TPLONWebSocketServer_Reaad = procedure (const str, from:String) of object;

  { TPLWebSocketServer }
  TPLWebSocketServer = class
  private
    fONWebSocketServer_Reaad: TPLONWebSocketServer_Reaad;
  protected

  public
    AppDir:string;
    SaveHost:string;
    Server:TWebSocketServer;
    SavePort:Integer;
    Error:Boolean;
    plThreadTimer:TPLThreadTimer;
    LastUpdate:Integer;
    StrListA:TStringList;

    constructor Create;
    destructor Destroy; override;

    function Start(Host:String; port:Integer):boolean;
    procedure LoadDefaultWebSite(var WebSite:string);

    procedure OnAfterAddConnection(aServer: TCustomServer; aConnection: TCustomConnection);
    procedure OnBeforeAddConnection(aServer: TCustomServer; aConnection: TCustomConnection; var CanAdd: boolean);
    procedure OnAfterRemoveConnection(aServer: TCustomServer; aConnection: TCustomConnection);
    procedure OnBeforeRemoveConnection(aServer: TCustomServer; aConnection: TCustomConnection);
    procedure OnServerSocketError(aServer: TCustomServer; Socket: TTCPBlockSocket);

    procedure OnOpen(aSender: TWebSocketCustomConnection);
    procedure OnRead(aSender: TWebSocketCustomConnection; aFinal, aRes1, aRes2, aRes3: boolean; aCode: integer; aData: TMemoryStream);

    procedure OnWrite(aSender: TWebSocketCustomConnection; aFinal, aRes1, aRes2, aRes3: boolean; aCode: integer; aData: TMemoryStream);
    procedure OnClose(aSender: TWebSocketCustomConnection; aCloseCode: integer; aCloseReason: string; aClosedByPeer: boolean);
    procedure OnConnectionSocket(Sender: TObject; Reason: THookSocketReason; const Value: String);

    procedure SendAText(const aText:String);

    procedure TextOut(Line:integer; const ID, Value, Einheit:String);
    procedure TimerEvent;

  published
    property ONWebSocketServer_Reaad:TPLONWebSocketServer_Reaad read fONWebSocketServer_Reaad write fONWebSocketServer_Reaad;


  end; // TPLWebSocketServer

var
    Server:TPLWebSocketServer;

implementation

uses math;


{ TPLWebSocketServer }
function ReadFileStream(f:TFileStream):string;
var
  ch:Char;
  str:String;
  r:integer;
begin
  ch:=' ';
  result:='';
  if Assigned(f) then begin
    f.Position:=0;
    str:='';
    repeat
      r:=f.Read(ch,1);
      str:=str+ch;
      sleep(10);
    until r <= 0;
    result:=str;
  end;
end;


constructor TPLWebSocketServer.Create;
begin
  inherited Create;
  StrListA:=TStringList.Create;
  AppDir:=ExtractFileDir(ParamStr(0))+DirectorySeparator;
  Error:=False;
  Server:=nil;
  fONWebSocketServer_Reaad:=nil;

  plThreadTimer:=TPLThreadTimer.Create(True);
  plThreadTimer.Interval:=1000;
  plThreadTimer.OnTimerEvent:=@TimerEvent;
  plThreadTimer.Enabled:=false;
end; // TPLWebSocketServer.Create

destructor TPLWebSocketServer.Destroy;
begin
  StrListA.Free;
  if Assigned(Server) then Server.free;
  inherited Destroy;
end; // TPLWebSocketServer.Destroy

function TPLWebSocketServer.Start(Host: String; port: Integer):boolean;
begin
  if Assigned(Server) then FreeAndNil(Server);
  SavePort:=Port;
  SaveHost:=Host;
  writeln('Host:',Host,' Port: ', Port);
  Server := TWebSocketServer.Create(Host, IntToStr(SavePort));
  server.OnLoadDefaultWebSite:=@LoadDefaultWebSite;
  Server.OnAfterAddConnection := @OnAfterAddConnection;
  Server.OnBeforeAddConnection := @OnBeforeAddConnection;
  Server.OnAfterRemoveConnection := @OnAfterRemoveConnection;
  Server.OnBeforeRemoveConnection := @OnBeforeRemoveConnection;
  Server.OnSocketError := @OnServerSocketError;

  Server.SSL:=False;
  Server.Start;
  result:=false;
end; // TPLWebSocketServer.Start

procedure TPLWebSocketServer.LoadDefaultWebSite(var WebSite: string);
var
  StrList, StrList2:TStringList;
  str, NewStr, FileName:String;
  i,x,x1,x2:Integer;
begin
  try
    StrList:=TStringList.Create;
    StrList2:=TStringList.Create;

    StrList.LoadFromFile(AppDir+'module/index.html');
    i:=0;
    while true do begin
      x1:=pos('{FileLoad:',StrList[i]);
      if X1 > 0 then begin
        x2:=PosEx('}',StrList[i],x1+1);
        FileName:=copy(StrList[i],X1+10,(X2-X1)-10);
        StrList.Delete(i);
        StrList2.LoadFromFile(AppDir+'module/'+FileName);

        for x:=0 to StrList2.Count-1 do begin
          StrList.Insert(i+x,StrList2[x]);
        end;
        i:=i+StrList2.Count-1;
      end;
      if i +1 >=StrList.Count then
        break
      else
        i:=i+1;
    end; // for i

    NewStr:=format('socket = new WebSocket(''ws://%s:%d'');',[SaveHost,SavePort]);
    for i:=0 to StrList.Count-1 do begin
      if Pos('socket = new WebSocket(',StrList[i]) > 0 then begin
        StrList[i]:=NewStr;
      end;
    end;
    WebSite:=StrList.Text;
  except
    on E: Exception do
      writeln('TPLWebSocketServer.LoadDefaultWebSite:',E.Message);
  end;
end; // TPLWebSocketServer.LoadDefaultWebSite

procedure TPLWebSocketServer.OnAfterAddConnection(aServer: TCustomServer; aConnection: TCustomConnection);
begin
  TWebSocketServerConnection(aConnection).OnWrite := @OnWrite;
  TWebSocketServerConnection(aConnection).OnRead := @OnRead;
  TWebSocketServerConnection(aConnection).OnClose := @OnClose;
  TWebSocketServerConnection(aConnection).OnOpen := @OnOpen;
end; // TPLWebSocketServer.OnAfterAddConnection

procedure TPLWebSocketServer.OnBeforeAddConnection(aServer: TCustomServer; aConnection: TCustomConnection; var CanAdd: boolean);
begin
end; // TPLWebSocketServer.OnBeforeAddConnection

procedure TPLWebSocketServer.OnAfterRemoveConnection(aServer: TCustomServer; aConnection: TCustomConnection);
begin

end; // TPLWebSocketServer.OnAfterRemoveConnection

procedure TPLWebSocketServer.OnBeforeRemoveConnection(aServer: TCustomServer; aConnection: TCustomConnection);
begin
end; // TPLWebSocketServer.OnBeforeRemoveConnection

procedure TPLWebSocketServer.OnServerSocketError(aServer: TCustomServer; Socket: TTCPBlockSocket);
begin
  Error:=True;
  if Socket.LastError = 98 then begin
    Start(SaveHost, SavePort+1);
  end
  else
    writeln(Format('%s - %d (%s)', [FormatDateTime('yyyy-mm-dd hh:nn:ss', now), Socket.LastError, Socket.LastErrorDesc]));

end; // TPLWebSocketServer.OnServerSocketError

procedure TPLWebSocketServer.OnOpen(aSender: TWebSocketCustomConnection);
begin

end; // TPLWebSocketServer.OnOpen

procedure TPLWebSocketServer.OnRead(aSender: TWebSocketCustomConnection; aFinal, aRes1, aRes2, aRes3: boolean; aCode: integer; aData: TMemoryStream);
var
  str,s:string;
begin
  try
    s := ReadStrFromStream(aData, min(aData.size, 10 * 1024));
    if (aCode = wsCodeText) then
      str := CharsetConversion(s, UTF_8, GetCurCP)
    else
      str:= s;
    StrListA.Add(s);
    StrListA.SaveToFile(AppDir+'test.txt');
    writeln('"',str,'"');
  except
    on E: Exception do
      writeln('TPLWebSocketServer.OnRead:',E.Message);
  end;
end; // TPLWebSocketServer.OnRead

procedure TPLWebSocketServer.OnWrite(aSender: TWebSocketCustomConnection; aFinal, aRes1, aRes2, aRes3: boolean; aCode: integer; aData: TMemoryStream);
begin
//  writeln('onWrite');
end; // TPLWebSocketServer.OnWrite

procedure TPLWebSocketServer.OnClose(aSender: TWebSocketCustomConnection; aCloseCode: integer; aCloseReason: string; aClosedByPeer: boolean);
begin
  aSender.Close(aCloseCode,aCloseReason);
//  Server.CloseAllConnections(aCloseCode,aCloseReason);
end; // TPLWebSocketServer.OnClose

procedure TPLWebSocketServer.OnConnectionSocket(Sender: TObject; Reason: THookSocketReason; const Value: String);
begin
  writeln('OnConnectionSocket');
end; // TPLWebSocketServer.OnConnectionSocket

procedure TPLWebSocketServer.SendAText(const aText: String);
var
  i:integer;
begin
  try
    if (Assigned(Server)) and (Server.Count >=1) then begin
      Server.LockTermination;
      for I := 0 to Server.Count - 1 do
        TWebSocketCustomConnection(Server.Connection[i]).SendText(CharsetConversion(aText, GetCurCP, UTF_8));
      Server.UnLockTermination;
    end;
  except
    on E: Exception do
      writeln('TPLWebSocketServer.SendAText:',E.Message);
  end;
end;

procedure TPLWebSocketServer.TextOut(Line:integer; const ID, Value, Einheit:String);
begin
  try
    SendAText('2$'+Value+' ' + Einheit+'$'+ID);
  except
    on E: Exception do
      writeln('TPLWebSocketServer.TextOut:',E.Message);
  end;
end;

procedure TPLWebSocketServer.TimerEvent;
begin
{  try
//    inc(LastUpdate);
//    SendAText('3$'+intTostr(LastUpdate));
  except
    on E: Exception do
      writeln('TPLWebSocketServer.TimerEvent:',E.Message);
  end;}
end; // TPLWebSocketServer.TimerEvent


end.

